-- =============================================
-- Author:		<Author,,Name>
-- Create date: <Create Date,,>
-- Description:	<Description,,>
-- =============================================
CREATE procedure [C6Mart].[RP_DM_ANAG_PRODOTTI_TERZI]
AS
BEGIN
	SET NOCOUNT ON;
	DECLARE @ID_ELAB INT
	DECLARE @TIPO_ELAB VARCHAR(1)
	SET @ID_ELAB = C6MART.GETIDELAB()
	SET @TIPO_ELAB = C6MART.GETTIPOELAB()
	-- Log esecuzione
	INSERT INTO LOG_ESECUZIONE
		(Nome, Inizio, Nota)
	VALUES (
		'RP_DM_ANAG_PRODOTTI_TERZI',
		GETDATE(),
		'Elaborazione giornaliera'
	)
	TRUNCATE TABLE C6MART.ANAG_PRODOTTI_TERZI
		INSERT INTO [C6Mart].[ANAG_PRODOTTI_TERZI]
		   ([COD_PRODOTTO]
		   ,[COD_PRODOTTO_TERZI]
		   ,[NOME_PRODOTTO]
		   ,[ALBERO_PRODOTTI]
		   ,[COD_ISIN]
		   ,[DESCR_PRODOTTO]
		   ,[DIV_QUOTAZIONE]
		   ,[INTERMEDIARIO]
		   ,[DIV_REGOLAMENTO]
		   ,[ID_EMITTENTE]
		   ,[MERCATO_CONTRATT]
		   ,[PAESE]
		   ,[RATING]
		   ,[ID_ELAB]
		   ,[TIPO_ELAB])
	SELECT 
		--C6Mart.VCONTRATTI.chiaveClientePB AS chiaveClientePB,
		C6Staging.RP_DettProdottiTerzi.chiaveProdotto AS COD_PRODOTTO,
		C6Staging.RP_PatrimonioTerzi.chiaveProdottoTerzi AS COD_PRODOTTO_TERZI,
		C6Staging.RP_PatrimonioTerzi.nomeProdotto AS NOME_PRODOTTO,
		NULL AS ALBERO_PRODOTTI, 
		NULL AS COD_ISIN,
		C6Staging.RP_PatrimonioTerzi.tipoprod AS DESCR_PRODOTTO,
		NULL AS DIV_QUOTAZIONE,
		NULL AS INTERMEDIARIO,
		NULL AS DIV_REGOLAMENTO,
		NULL AS ID_EMITTENTE,
		NULL AS MERCATO_CONTRATT,
		NULL AS PAESE,
		NULL AS RATING,
		@ID_ELAB AS ID_ELAB,
		@TIPO_ELAB AS TIPO_ELAB
		--INTO C6MART.ANAG_PRODOTTI_TERZI
	FROM C6Staging.RP_DettProdottiTerzi
	INNER JOIN C6Staging.RP_PatrimonioTerzi
	ON C6Staging.RP_DettProdottiTerzi.chiaveProdottoTerzi = C6Staging.RP_PatrimonioTerzi.chiaveProdottoTerzi
	INNER JOIN C6Mart.VCONTRATTI
	ON C6Staging.RP_PatrimonioTerzi.chiaveClientePB = C6Mart.VCONTRATTI.chiaveClientePB
	-- Log esecuzione
	UPDATE
		LOG_ESECUZIONE
	SET
		Fine = GETDATE(),
		Tipo = 'INSERT',
		Righe = @@ROWCOUNT
	WHERE
		Nome = 'RP_DM_ANAG_PRODOTTI_TERZI' AND
		Inizio = (
			SELECT
				MAX(Inizio)
			FROM
				LOG_ESECUZIONE
			WHERE
				Nome = 'RP_DM_ANAG_PRODOTTI_TERZI'
		)
END